unit UMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, IdBaseComponent, IdComponent, IdTCPConnection,
  IdTCPClient, IdHTTP, FrameHoras,
  ulkJSon, UTWeatherClass, ExtCtrls, TeeGDIPlus, TeEngine, Series, TeeProcs, Chart,
{$IFDEF DELPHIXE_UP}
  Vcl.ComCtrls, Vcl.Imaging.pngimage, Vcl.Imaging.jpeg, Vcl.WinXCtrls,
  jpeg, ComCtrls, TeeGDIPlus, TeEngine, Series, TeeProcs, Chart;
{$ELSE}
	ComCtrls, jpeg;
{$ENDIF}

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    edtCiudad: TEdit;
    IdHTTP: TIdHTTP;
    Button3: TButton;
    edtTiempoCiudad: TEdit;
    edtLat: TEdit;
    edtLon: TEdit;
    pnlDatos: TPanel;
    lblCiudad: TLabel;
    lblTemp: TLabel;
    imgTiempo: TImage;
    lblNuves: TLabel;
    lblTempMin: TLabel;
    lblTempMax: TLabel;
    btnProxHoras: TButton;
    pcResult: TPageControl;
    TabSheet1: TTabSheet;
    tsHoras: TTabSheet;
    TabSheet3: TTabSheet;
    mmData: TMemo;
    lblHumedad: TLabel;
    imgHumedad: TImage;
    imgPresure: TImage;
    lblPresure: TLabel;
    lblViento: TLabel;
    imgViento: TImage;
    lblVclStyle: TLabel;
    cbxVclStyles: TComboBox;
    imgTest: TImage;
    sbHoras: TScrollBox;
    btnBuscarCiudad: TButton;
    tsCiudades: TTabSheet;
    lbCiudades: TListBox;
    Chart1: TChart;
    Series1: TLineSeries;
    procedure Button2Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure btnProxHorasClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure cbxVclStylesChange(Sender: TObject);
    procedure pcResultChange(Sender: TObject);
    procedure btnBuscarCiudadClick(Sender: TObject);
    procedure edtCiudadKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure lbCiudadesKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    FResp: TStringStream;
    FResponse: string;
    objResp:TlkJSONobject;
    errCode:integer;
    errMsg:string;
    FrameHorasList:TStringList;

    function GetFormattedResponse(AResponse:String):string;

    // Parsea la respuesta a una estructura que nos ha devuelto la web
    function ParseTiempo(AObjResp:TlkJSONobject; var ATiempoObj:TTiempoStruct):Boolean;
    // Parsea la respuesta de varias ciudades a una estructura que nos ha devuelto la web
    function ParseTiempoCiudades(AObjResp:TlkJSONobject; var ATiempoObj:TTiempoStruct):Boolean;
    function ParseTiempoCiudadesHist(AObjResp:TlkJSONobject; var ATiempoProxHoras:TTiempoProxHoras):Boolean;
    // Obtener datos de la respuesta...
  	function ParseForecast(AObjResp:TlkJSONobject; var AForecastData:TForecastStruct):Boolean;
    // Obtener la lista de ciudades de un consulta
    function ParseCiudades(AObjResp:TlkJSONobject; var AListaCiudades:TListaCiudades):boolean;
    // descargar una imagen
    procedure DownloadImage(URLImage:string; APath:string);
    // Actualizar datos en pantalla
    procedure ActualizarInfoTiempo(ATiempoData:TTiempoStruct); overload;
    procedure ActualizarInfoTiempo(ATiempoProxHoras:TTiempoProxHoras); overload;
    procedure ActualizarFrameHoras(AFrame:TfrHoras; ATiempoProxHora:TTiempoProxHora);
  public



  end;

var
  Form1: TForm1;


//=========================================================================
//
// I M P L E M E N T A T I O N
//
//=========================================================================
implementation

{$R *.dfm}

uses
{$IFDEF DELPHIXE_UP}
  System.StrUtils, Vcl.Themes,
{$ELSE}
  StrUtils, pngImage,
{$ENDIF}
  UCommonConstantes, UConstantes, UCommonProcedures, DateUtils, XSBuiltIns;

procedure PNGFileToBitmap(const Source, Dest: String); overload;
var
  Bitmap: TBitmap;
  PNG: TPNGObject;
begin
  PNG := TPNGObject.Create;
  Bitmap := TBitmap.Create;
  {In case something goes wrong, free booth PNG and Bitmap}
  try
    PNG.LoadFromFile(Source);
    Bitmap.Assign(PNG);    //Convert data into bitmap
    Bitmap.SaveToFile(Dest);
  finally
    PNG.Free;
    Bitmap.Free;
  end
end;

procedure PNGFileToBitmap(const Source:string; var ABitmap:TBitmap); overload;
var
  PNG: TPNGObject;
begin
  PNG := TPNGObject.Create;
  try
    PNG.LoadFromFile(Source);
    ABitmap.Assign(PNG);    //Convert data into bitmap
    // ABitmap.SaveToFile(Dest);
  finally
    PNG.Free;
  end
end;





procedure TForm1.Button2Click(Sender: TObject);
var
  StrW, Str:String;
  ATiempoData:TTiempoStruct;
begin
  // Ini
	// realizar el envo
  try
    Str := AnsiReplaceText(edtCiudad.Text, CHAR_SPACE, '%20');
    StrW := Format(URL_SEARCH_CITY,[UTF8Encode(Str)]) + STR_APPID;
    Self.FResponse := Self.IdHTTP.Get(StrW);
  except
    on E:Exception do begin
      MessageDlg('Error:' + E.Message, mtError, [mbOK], 0);
    end;
  end;
  // Hacer un parse de la respuesta
  mmData.Lines.Text := GetFormattedResponse(Self.FResponse);
	// Hacer un parse de la respuesta
  TlkJSONbase(objResp) := TlkJSON.ParseText(Self.FResponse);
	// parsear la respuesta
  ParseTiempoCiudades(objResp, ATiempoData);
  // Actualizar datos en pantalla
  ActualizarInfoTiempo(ATiempoData);

  //Automticamente llamamos a la previsin posterior
  btnProxHorasClick(nil);
  

end;


//: Obtener la cadena de respuesta formateada.
function TForm1.GetFormattedResponse(AResponse:String):string;
var
  obj:TlkJSONbase;
  vLevel:Integer;
begin
  // ini
  Result := STR_EMPTY;
	// vaco?
  if (AResponse = STR_EMPTY) then begin
    Exit;
  end;

  // Conseguir la cadena formateada.
  obj := TlkJSONbase.Create();
  // proteccion
  try
  	vLevel := 0;
    obj := TlkJSON.ParseText(AResponse);
    Result := GenerateReadableText(obj, vLevel);        // pROBLEMA CON LA 
  finally
	FreeAndNil(obj);
  end;
end;


procedure TForm1.lbCiudadesKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  // Si es un ENTER y hay algo seleccionado? lo pasamos arriba
  if (key = VK_RETURN) and (lbCiudades.ItemIndex <> -1) then begin
    edtCiudad.Text := lbCiudades.Items[lbCiudades.ItemIndex];
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  StyleName: string;
begin
  // ini
  FrameHorasList := TStringList.Create();
{$IFDEF DELPHIXE_UP}
  // rellenar estilos
  for StyleName in TStyleManager.StyleNames do begin
    cbxVclStyles.Items.Add(StyleName);
  end;
  // Activar
  cbxVclStyles.ItemIndex := cbxVclStyles.Items.IndexOf(TStyleManager.ActiveStyle.Name);
{$ENDIF}

end;

procedure TForm1.FormShow(Sender: TObject);
begin

  // ini
  pcResult.ActivePageIndex := 0;
 	IdHTTP.HandleRedirects := True;
	// Crear variables
	Self.FResp := TStringStream.Create(STR_EMPTY);


end;

procedure TForm1.ActualizarInfoTiempo(ATiempoData: TTiempoStruct);
var
  fName, sIcon, fPath:string;
  bmp:TBitmap;
begin
  // Resultado
  lblCiudad.Caption := ATiempoData.name;
  lblTemp.Caption := FloatToStrF(ATiempoData.Main.temp, ffGeneral, 2, 1) + ' ';
  lblTempMin.Caption := FloatToStrF(ATiempoData.Main.tempmin, ffGeneral, 2, 1) + ' ';
  lblTempMax.Caption := FloatToStrF(ATiempoData.Main.tempmax, ffGeneral, 2, 1) + ' ';
  lblNuves.Caption := ATiempoData.Weather[0].desc;

  sIcon := ATiempoData.Weather[0].icon;
  fName := URL_ICON_PATH + sIcon + '.png';
  // Descargar imagen
  fPath := ExtractFilePath(Application.ExeName) + 'Temporal\' + sIcon + '.png';
  if (not FileExists(fPath)) then begin
    DownloadImage(fName , fPath);
  end;

  // Generar bitmap
  bmp := TBitmap.Create();
  PNGFileToBitmap(fPath, bmp);
  imgTiempo.Picture.Bitmap.Assign(bmp);
  bmp.Free;

  // Otros
  lblHumedad.Caption := Format('Humedad del %d%%', [Trunc(ATiempoData.Main.humidity)]);
  lblPresure.Caption := Format('Presin del %d hpa', [Trunc(ATiempoData.Main.pressure)]);
  lblViento.Caption := Format('Velocidad del viento de %f m/s', [ATiempoData.Wind.speed]);
end;

procedure TForm1.ActualizarFrameHoras(AFrame: TfrHoras; ATiempoProxHora:TTiempoProxHora);
var
  sIcon, fName, fPath:String;
  bmp:TBitmap;
  str:String;
begin
  // rellenar el icono
  sIcon := ATiempoProxHora.weather.icon;
  fName := URL_ICON_PATH + sIcon + '.png';
  // Descargar imagen
  fPath := ExtractFilePath(Application.ExeName) + 'Temporal\' + sIcon + '.png';
  if (not FileExists(fPath)) then begin
    DownloadImage(fName , fPath);
  end;

  // Generar bitmap
  bmp := TBitmap.Create();
  PNGFileToBitmap(fPath, bmp);
  AFrame.imgTiempo.Picture.Bitmap.Assign(bmp);
  bmp.Free;

  // Otros Datos
  AFrame.lblNuves.Caption := ATiempoProxHora.Weather.desc;
  AFrame.lblTemp.Caption := IntToStr(Round(ATiempoProxHora.Main.temp)) + ' ';
  AFrame.lblTempMin.Caption := IntToStr(Round(ATiempoProxHora.Main.tempmin)) + ' ';
  AFrame.lblTempMax.Caption := IntToStr(Round(ATiempoProxHora.Main.tempmax)) + ' ';
  // dia y hora
  AFrame.lblDia.Caption := FormatDateTime('ddd d', ATiempoProxHora.dt);
  AFrame.lblHora.Caption := FormatDateTime('hh:nn', ATiempoProxHora.dt);

// debug
//  Str := ATiempoProxHora.dt_text;
//  MessageDlg('dt_Text: ' + Str, mtInformation, [mbOK], 0);
//  Str := DateTimeToStr(ATiempoProxHora.dt);
//  MessageDlg('dt: ' + Str, mtInformation, [mbOK], 0);
end;


procedure TForm1.ActualizarInfoTiempo(ATiempoProxHoras: TTiempoProxHoras);
var
  i: Integer;
  fr:TfrHoras;
begin
  // Si ya estn creados, los eliminamos
  if (FrameHorasList.Count  > 0) then begin
    for i := 0 to (FrameHorasList.Count  - 1) do begin
      fr := TfrHoras(FrameHorasList.Objects[i]);
      fr.Free;
    end;
    FrameHorasList.Clear;
  end;


  // cambiar la pestaa
  pcResult.ActivePage := tsHoras;
  // Borrar datyos de la serie
  Series1.Clear;

  // para cada elemento
  for i := 0 to 15 {Length(ATiempoProxHoras.TiempoHora) - 1} do begin
    // Crear el Frame.
    fr := TfrHoras.Create(Self);
    fr.Name := 'Framehoras' + IntToStr(i);
    fr.Parent := sbHoras;
    fr.Top := i * (fr.Height) - 10;
    fr.Align := alTop;
    // Aadirlo a la lista
    FrameHorasList.AddObject(fr.Name, fr);
    // rellenarlo
    ActualizarFrameHoras(fr, ATiempoProxHoras.TiempoHora[i]);



    // Aadir datos a la serie
    Series1.AddY(ATiempoProxHoras.TiempoHora[i].main.temp, IntToStr(i));

  end;

end;


procedure TForm1.Button1Click(Sender: TObject);
var
  StrW:String;
  ATiempoData:TTiempoStruct;
begin
	// realizar el envo
  try
    StrW := Format(URL_BASE_LAT_LON_STR, [edtLat.Text, edtLon.Text]) + PARAMS;
    Self.FResponse := Self.IdHTTP.Get(StrW);
  except
    on E:Exception do begin
      MessageDlg('Error:' + E.Message, mtError, [mbOK], 0);
    end;
  end;
  // Hacer un parse de la respuesta
  mmData.Lines.Text := GetFormattedResponse(Self.FResponse);
	// Hacer un parse de la respuesta
  TlkJSONbase(objResp) := TlkJSON.ParseText(Self.FResponse);
  // Obtener datos de la respuesta...
  ParseTiempo(objResp, ATiempoData);

end;

procedure TForm1.Button3Click(Sender: TObject);
var
  StrW:String;
  ATiempoData:TTiempoStruct;
  str:String;
begin
	// realizar el envo
  try
    Str := AnsiReplaceText(edtTiempoCiudad.Text, CHAR_SPACE, '%20');
    StrW := Format(URL_BASE_CITYNAME,[UTF8Encode(Str)]) + PARAMS;
    Self.FResponse := Self.IdHTTP.Get(StrW);
  except
    on E:Exception do begin
      MessageDlg('Error:' + E.Message, mtError, [mbOK], 0);
    end;
  end;
  // Hacer un parse de la respuesta
  mmData.Lines.Text := GetFormattedResponse(Self.FResponse);
	// Hacer un parse de la respuesta
  TlkJSONbase(objResp) := TlkJSON.ParseText(Self.FResponse);
	// parsear la respuesta
  ParseTiempo(objResp, ATiempoData);
  // Actualizar datos en pantalla
  ActualizarInfoTiempo(ATiempoData);

end;

// Obtener datos de la respuesta...
procedure TForm1.pcResultChange(Sender: TObject);
begin
  // estamos activando la segunda
  if (pcResult.ActivePageIndex = 1) then begin
    btnProxHorasClick(nil);
  end;

end;

// Obtener la lista de ciudades de un consulta
function TForm1.ParseCiudades(AObjResp: TlkJSONobject; var AListaCiudades: TListaCiudades): boolean;
var
  i, j: integer;
  oList: TlkJSONlist;
  oCity, oCoord, oSys: TlkJSONobject;
begin
  // ini
  Result := False;
  // Si no est asignado salimos..
  if not Assigned(AobjResp) then begin
  	Exit;
  end;
  // Si hay error no parseamos
	if IsErrorResponse(AObjResp, errCode, ErrMsg) then begin
  	Exit;
  end;
  // proteccion para el parseo
  try
    // cod. devuelto (datos principales
    AListaCiudades.cod := errCode;
    // Parseo de los datos
    //------------------------------------
    AListaCiudades.cont := GetAsInteger(AObjResp.Field['count'].Value);
		// Lista de dias devueltos
    TlkJSONBase(oList) := AObjResp.Field['list'];
    // array de elementos
    SetLength(AListaCiudades.ciudades, oList.Count);
    // Recorrer la lista de objetos.
    for i := 0 to (oList.Count - 1) do begin
      // Datos de la bsicos
      TlkJSONBase(ocity) := oList.Child[i];
      AListaCiudades.ciudades[i].nombre := GetAsString(ocity.Field['name'].Value);

      TlkJSONBase(oSys) := ocity.Field['sys'];
      AListaCiudades.ciudades[i].pais := GetAsString(oSys.Field['country'].Value);

      TlkJSONBase(oCoord) := ocity.Field['coord'];
      AListaCiudades.ciudades[i].coord.Lat := GetAsFloat(oCoord.Field['lat'].Value);
      AListaCiudades.ciudades[i].coord.Lon := GetAsFloat(oCoord.Field['lon'].Value);
    end;

    Result := True;
  except
		// si hay error, FALSe
    Result := False;
  end;
end;

function TForm1.ParseForecast(AObjResp: TlkJSONobject; var AForecastData: TForecastStruct): Boolean;
var
  oCity, oCoord, oDay, oTemp, oWeather:TlkJSONobject;
  oList, OWList:TlkJSONlist;
  i, j:integer;
begin
  // ini
  Result := False;
  // Si no est asignado salimos..
  if not Assigned(AobjResp) then begin
  	Exit;
  end;
  // Si hay error no parseamos
	if IsErrorResponse(AObjResp, errCode, ErrMsg) then begin
  	Exit;
  end;

  // proteccion para el parseo
  try
    // cod. devuelto (datos principales
    AForecastData.Cod := IntToStr(errCode);
    // Parseo de los datos
    //------------------------------------

    // Basicos
    AForecastData.msg	:= GetAsFloat(AObjResp.Field['message'].Value);
    AForecastData.dayscount := GetAsInteger(AObjResp.Field['cnt'].Value);

    // city
    TlkJSONBase(oCity) := AObjResp.Field['city'];
    AForecastData.city.id := GetAsInteger(oCity.Field['id'].Value);
    AForecastData.city.name := GetAsString(oCity.Field['name'].Value);
    AForecastData.city.country := GetAsString(oCity.Field['country'].Value);
    TlkJSONBase(oCoord) := oCity.Field['coord'];
    AForecastData.city.coord.Lat := GetAsFloat(oCoord.Field['lat'].Value);
    AForecastData.city.coord.Lon := GetAsFloat(oCoord.Field['lon'].Value);

		// Lista de dias devueltos
    TlkJSONBase(oList) := AObjResp.Field['list'];
    // array de elementos
    SetLength(AForecastData.days, oList.Count);
    // Recorrer la lista de objetos.
    for i := 0 to (oList.Count - 1) do begin
      // Datos de la bsicos
      TlkJSONBase(oDay) := oList.Child[i];
      AForecastData.days[i].dt := GetAsInt64(oDay.Field['dt'].Value);
      AForecastData.days[i].presure := GetAsFloat(oDay.Field['pressure'].Value);
      AForecastData.days[i].humidity := GetAsInteger(oDay.Field['humidity'].Value);

      AForecastData.days[i].speed := GetAsFloat(oDay.Field['speed'].Value);
      AForecastData.days[i].deg := GetAsInteger(oDay.Field['deg'].Value);
      AForecastData.days[i].cloud := GetAsInteger(oDay.Field['clouds'].Value);

      // temperaturas
      TlkJSONBase(oTemp) := oDay.Field['temp'];
      AForecastData.days[i].temp.day := GetAsFloat(oTemp.Field['day'].Value);
      AForecastData.days[i].temp.min := GetAsFloat(oTemp.Field['min'].Value);
      AForecastData.days[i].temp.max := GetAsFloat(oTemp.Field['max'].Value);
      AForecastData.days[i].temp.night := GetAsFloat(oTemp.Field['night'].Value);
      AForecastData.days[i].temp.eve := GetAsFloat(oTemp.Field['eve'].Value);
      AForecastData.days[i].temp.morn := GetAsFloat(oTemp.Field['morn'].Value);
      // Weather
      TlkJSONBase(OWList) := oDay.Field['weather'];
      // array de elementos
	    SetLength(AForecastData.days[i].Weather, OWList.Count);
      // Recorrer la lista de objetos.
      for j := 0 to (oWList.Count - 1) do begin
        // Datos de la farmacia
        TlkJSONBase(oWeather) := oWList.Child[j];
        AForecastData.days[i].Weather[j].id := GetAsInteger(oWeather.Field['id'].Value);
        AForecastData.days[i].Weather[j].main := GetAsString(oWeather.Field['main'].Value);
        AForecastData.days[i].Weather[j].desc := GetAsString(oWeather.Field['description'].Value);
        AForecastData.days[i].Weather[j].icon := GetAsString(oWeather.Field['icon'].Value);
      end;
    end;

    Result := True;
  except
		// si hay error, FALSe
    Result := False;
  end;
end;


function TForm1.ParseTiempoCiudadesHist(AObjResp: TlkJSONobject; var ATiempoProxHoras: TTiempoProxHoras): Boolean;
var
  i, j, num, index:integer;
  oHorasList, OWList:TlkJSONlist;
  oHora, oCoord, oMain, oWind, oWeather:TlkJSONobject;
  Str:String;
begin
  // ini
  Result := False;
  // Si no est asignado salimos..
  if not Assigned(AobjResp) then begin
  	Exit;
  end;
  // Si hay error no parseamos
	if IsErrorResponse(AObjResp, errCode, ErrMsg) then begin
  	Exit;
  end;

  // proteccion para el parseo
  try
    // cod. devuelto (datos principales
    ATiempoProxHoras.Cod := errCode;

    num := AObjResp.IndexOfName('count');
    if (num <> -1) then begin
      num := GetAsInteger(AObjResp.Field['count'].Value);
    end;

    // si no hay ciudades
    if (num = 0) then begin
      MessageDlg('No hay ninguna ciudad que coincida con ese cdigo <nombre,pais>.', mtWarning, [mbOK], 0);
      Exit;
    end;

    // Lista de horas (Lista)
    TlkJSONBase(oHorasList) := AObjResp.Field['list'];
    // array de elementos
    SetLength(ATiempoProxHoras.TiempoHora, oHorasList.Count);
    // Quedarse con el primier elemento de la lista...
    for i := 0 to (oHorasList.Count - 1) do begin
      // datos de la primera ciudad
      TlkJSONBase(oHora) := oHorasList.Child[i];
      // datos bsicos
      ATiempoProxHoras.TiempoHora[i].dt_text := GetAsString(oHora.Field['dt_txt'].Value);
      // convertir fecha-Hora
      Str := ATiempoProxHoras.TiempoHora[i].dt_text;
      ATiempoProxHoras.TiempoHora[i].dt := EncodeDateTime(
        StrToIntdef(Copy(Str, 1, 4), 0),
        StrToIntdef(Copy(Str, 6, 2), 0),
        StrToIntdef(Copy(Str, 9, 2), 0),
        StrToIntdef(Copy(Str, 12, 2), 0),
        StrToIntdef(Copy(Str, 15, 2), 0),
        StrToIntdef(Copy(Str, 18, 2), 0), 0);


      // Load Main
      TlkJSONBase(oMain) := oHora.Field['main'];
      ATiempoProxHoras.TiempoHora[i].Main.temp := GetAsFloat(oMain.Field['temp'].Value);
      ATiempoProxHoras.TiempoHora[i].Main.tempmin := GetAsFloat(oMain.Field['temp_min'].Value);
      ATiempoProxHoras.TiempoHora[i].Main.tempmax := GetAsFloat(oMain.Field['temp_max'].Value);
      ATiempoProxHoras.TiempoHora[i].Main.pressure := GetAsFloat(oMain.Field['pressure'].Value);
      ATiempoProxHoras.TiempoHora[i].Main.humidity := GetAsInteger(oMain.Field['humidity'].Value);

      // Load weather
      TlkJSONBase(OWList) := oHora.Field['weather'];
      TlkJSONBase(oWeather) := oWList.Child[0];
      ATiempoProxHoras.TiempoHora[i].Weather.id := GetAsInteger(oWeather.Field['id'].Value);
      ATiempoProxHoras.TiempoHora[i].Weather.main := GetAsString(oWeather.Field['main'].Value);
      ATiempoProxHoras.TiempoHora[i].Weather.desc := GetAsString(oWeather.Field['description'].Value);
      ATiempoProxHoras.TiempoHora[i].Weather.icon := GetAsString(oWeather.Field['icon'].Value);



    end;

    Result := True;
  except
		// si hay error, FALSe
    Result := False;
  end;

end;


// Parsea la respuesta de varias ciudades a una estructura que nos ha devuelto la web
function TForm1.ParseTiempoCiudades(AObjResp:TlkJSONobject; var ATiempoObj:TTiempoStruct):Boolean;
var
  i, j, num, index:integer;
  oCityList, OWList:TlkJSONlist;
  oCity, oCoord, oMain, oWind, oWeather:TlkJSONobject;
begin
  // ini
  Result := False;
  // Si no est asignado salimos..
  if not Assigned(AobjResp) then begin
  	Exit;
  end;
  // Si hay error no parseamos
	if IsErrorResponse(AObjResp, errCode, ErrMsg) then begin
  	Exit;
  end;

  // proteccion para el parseo
  try
    // cod. devuelto (datos principales
    ATiempoObj.Cod := errCode;

    num := AObjResp.IndexOfName('count');
    if (num <> -1) then begin
      num := GetAsInteger(AObjResp.Field['count'].Value);
    end;

    // si no hay ciudades
    if (num = 0) then begin
      MessageDlg('No hay ninguna ciudad que coincida con ese cdigo <nombre,pais>.', mtWarning, [mbOK], 0);
      Exit;
    end;

    // Ciudades (Lista)
    TlkJSONBase(oCityList) := AObjResp.Field['list'];
    // array de elementos
//    SetLength(ATiempoObj.Weather, oCityList.Count);
    // Quedarse con el primier elemento de la lista...
//    for i := 0 to (oWeatherList.Count - 1) do begin
    // datos de la primera ciudad
    TlkJSONBase(oCity) := oCityList.Child[0];
    // datos bsicos
    ATiempoObj.id := GetAsInteger(oCity.Field['id'].Value);
    ATiempoObj.Name := GetAsString(oCity.Field['name'].Value);
    // Parseo de coordenadas
    TlkJSONBase(oCoord)  	 	:= oCity.Field['coord'];
    ATiempoObj.Coord.Lat	 	:= GetAsFloat(oCoord.Field['lat'].Value);
    ATiempoObj.Coord.Lon	 	:= GetAsFloat(oCoord.Field['lon'].Value);
    // main
    TlkJSONBase(oMain) := oCity.Field['main'];
    ATiempoObj.Main.temp := GetAsFloat(oMain.Field['temp'].Value);
    ATiempoObj.Main.tempmin := GetAsFloat(oMain.Field['temp_min'].Value);
    ATiempoObj.Main.tempmax := GetAsFloat(oMain.Field['temp_max'].Value);
    ATiempoObj.Main.pressure := GetAsFloat(oMain.Field['pressure'].Value);
    ATiempoObj.Main.humidity := GetAsInteger(oMain.Field['humidity'].Value);
    // Viento
    TlkJSONBase(oWind) := oCity.Field['wind'];
    ATiempoObj.Wind.speed := GetAsFloat(owind.Field['speed'].Value);
    ATiempoObj.Wind.deg := GetAsInteger(oWind.Field['deg'].value);
    // ATiempoObj.Wind.gust := GetAsFloat(GetFieldExt(oWind, 'gust'));
    // Weather
    TlkJSONBase(OWList) := oCity.Field['weather'];
    // array de elementos
    SetLength(ATiempoObj.Weather, OWList.Count);
    // Recorrer la lista de objetos.
    for j := 0 to (oWList.Count - 1) do begin
      // Datos weather
      TlkJSONBase(oWeather) := oWList.Child[j];
      ATiempoObj.Weather[j].id := GetAsInteger(oWeather.Field['id'].Value);
      ATiempoObj.Weather[j].main := GetAsString(oWeather.Field['main'].Value);
      ATiempoObj.Weather[j].desc := GetAsString(oWeather.Field['description'].Value);
      ATiempoObj.Weather[j].icon := GetAsString(oWeather.Field['icon'].Value);
    end;


    Result := True;
  except
		// si hay error, FALSe
    Result := False;
  end;

end;


// Parsea la respuesta a una estructura que nos ha devuelto la web
function TForm1.ParseTiempo(AObjResp: TlkJSONobject; var ATiempoObj:TTiempoStruct): Boolean;
var
	oCoord, oSys, oWeather, oMain, oWind, oCloud, oRain, oSnow:TlkJSONobject;
  oWeatherList:TlkJSONlist;
  i64:Int64;
  i:Integer;
  d:TDateTime;
  str:string;

  //
  // devuelve el Variant del campo o null si no lo encuentra
  function GetFieldExt(AObject:TlkJSONobject; AName:String):Variant;
  var
    f:TlkJSONbase;
	begin
		Result := Variants.Null();
    f := nil;
    // Est el campo?
    f := AObject.Field[AName];
    // encontrado?
    if Assigned(f) then begin
	  	Result := f.Value;
    end;
  end;
  //

begin
  // ini
  Result := False;
  // Si no est asignado salimos..
  if not Assigned(AobjResp) then begin
  	Exit;
  end;
  // Si hay error no parseamos
	if IsErrorResponse(AObjResp, errCode, ErrMsg) then begin
  	Exit;
  end;

  // proteccion para el parseo
  try
    // cod. devuelto (datos principales
    ATiempoObj.Cod := errCode;

    // Parseo de coordenadas
    TlkJSONBase(oCoord)  	 	:= AObjResp.Field['coord'];
    ATiempoObj.Coord.Lat	 	:= GetAsFloat(oCoord.Field['lat'].Value);
    ATiempoObj.Coord.Lon	 	:= GetAsFloat(oCoord.Field['lon'].Value);
    // Parseo de valores de system
    TlkJSONBase(oSys) := AObjResp.Field['sys'];
    ATiempoObj.Sys.msg := GetAsFloat(oSys.Field['message'].Value);
    ATiempoObj.Sys.country := GetAsString(oSys.Field['country'].Value);
    // sunrise
    i64	:= GetAsInt64(oSys.Field['sunrise'].Value);
    // convertirlo a hora CEST  (est en UTC)
    d := UnixToDateTime(i64);
    str := DateTimeToXMLTime(d, False);
    ATiempoObj.Sys.sunrise := XMLTimeToDateTime(Str);
    // Sunset
    i64 := GetAsInt64(oSys.Field['sunset'].Value);
    d := UnixToDateTime(i64);
    str := DateTimeToXMLTime(d, False);
    ATiempoObj.Sys.sunset := XMLTimeToDateTime(Str);

    // weather (Lista)
    TlkJSONBase(oWeatherList) := AObjResp.Field['weather'];
    // array de elementos
    SetLength(ATiempoObj.Weather, oWeatherList.Count);
    // Recorrer la lista de objetos.
    for i := 0 to (oWeatherList.Count - 1) do begin
      // Datos de la farmacia
      TlkJSONBase(oWeather) := oWeatherList.Child[i];
      ATiempoObj.Weather[i].id := GetAsInteger(oWeather.Field['id'].Value);
      ATiempoObj.Weather[i].main := GetAsString(oWeather.Field['main'].Value);
      ATiempoObj.Weather[i].desc := GetAsString(oWeather.Field['description'].Value);
      ATiempoObj.Weather[i].icon := GetAsString(oWeather.Field['icon'].Value);
    end;

    // main
    TlkJSONBase(oMain) := AObjResp.Field['main'];
    ATiempoObj.Main.temp := GetAsFloat(oMain.Field['temp'].Value);
    ATiempoObj.Main.tempmin := GetAsFloat(oMain.Field['temp_min'].Value);
    ATiempoObj.Main.tempmax := GetAsFloat(oMain.Field['temp_max'].Value);
    ATiempoObj.Main.pressure := GetAsFloat(oMain.Field['pressure'].Value);
    ATiempoObj.Main.sealevel := GetAsFloat(GetFieldExt(oMain, 'sea_level'));
    ATiempoObj.Main.grnlevel := GetAsFloat(GetFieldExt(oMain, 'grnd_level'));
    ATiempoObj.Main.humidity := GetAsInteger(oMain.Field['humidity'].Value);

    // Viento
    TlkJSONBase(oWind) := AObjResp.Field['wind'];
    ATiempoObj.Wind.speed := GetAsFloat(GetFieldExt(oWind, 'speed'));
    ATiempoObj.Wind.deg := GetAsInteger(GetFieldExt(oWind, 'deg'));
    ATiempoObj.Wind.gust := GetAsFloat(GetFieldExt(oWind, 'gust'));

    // Clouds, nuves
    TlkJSONBase(oCloud) := AObjResp.Field['clouds'];
    ATiempoObj.Clouds.All := GetAsInteger(oCloud.Field['all'].Value);

    // rain, lluvia
    TlkJSONBase(oRain) := AObjResp.Field['rain'];
    ATiempoObj.Rain.Last3h := 0;
    if Assigned(oRain) then begin
      ATiempoObj.Rain.Last3h := GetAsInteger(GetFieldExt(oRain, '3h'));
    end;

    // snow, nieve
    TlkJSONBase(oSnow) := AObjResp.Field['snow'];
    ATiempoObj.Snow.Last3h := 0;
    if Assigned(oSnow) then begin
      ATiempoObj.Snow.Last3h := GetAsInteger(GetFieldExt(oSnow, '3h'));
    end;

    // principales
    ATiempoObj.dt := GetAsInt64(AObjResp.Field['dt'].Value);
    ATiempoObj.id := GetAsInt64(AObjResp.Field['id'].Value);
    ATiempoObj.name := GetAsString(AObjResp.Field['name'].Value);
    ATiempoObj.Base := GetAsString(AObjResp.Field['base'].Value);

    Result := True;
  except
		// si hay error, FALSe
    Result := False;
  end;
end;

//: recupara la imagen y la guarda en disco
procedure TForm1.DownloadImage(URLImage:string; APath:string);
var
  Stream:TFileStream;
  IdH:TidHTTP;
  path:string;
  dir:string;
begin
  // Nombre vaco
  if (URLImage = STR_EMPTY) then begin
    Exit;
  end;
  // Crearlo por si no existe
  ForceDirectories(ExtractFilePath(APath));
  try
    // Stream para la imagfen
    Stream  := TFileStream.Create(APath, fmCreate);
    try
      //recuperar la imagen
      IdH := TidHTTP.Create(nil);
      IdH.AllowCookies := True;
      // proteccion
      try
        IdH.Get(Trim(URLImage), Stream);
      except
        // Error al descargar la imagen
        //..  Volcarlo al log
      end;
    finally
      // Liberar
      idH.Free;
      Stream.Free;
    end;
  except
    // error al crear el fichero
    //...  Log
  end;
end;

procedure TForm1.edtCiudadKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  // entar, realiza la busqueda
  if (Key = VK_RETURN) then begin
    btnBuscarCiudadClick(nil);
  end;
end;

procedure TForm1.btnBuscarCiudadClick(Sender: TObject);
var
  Str, StrW:String;
  AForecastData:TForecastStruct;
  lCiudades:TListaCiudades;
  I: Integer;
begin
	// proximos 14 das...
  try
    Str := AnsiReplaceText(edtCiudad.Text, CHAR_SPACE, '%20');
    StrW := Format(URL_SEARCH_CITIES,[UTF8Encode(Str)]) + STR_APPID;
    Self.FResponse := Self.IdHTTP.Get(StrW);
  except
    on E:Exception do begin
      MessageDlg('Error:' + E.Message, mtError, [mbOK], 0);
    end;
  end;
  // Hacer un parse de la respuesta
  mmData.Lines.Text := GetFormattedResponse(Self.FResponse);
	// Hacer un parse de la respuesta
  TlkJSONbase(objResp) := TlkJSON.ParseText(Self.FResponse);

	// parsear la respuesta
  ParseCiudades(objResp, lCiudades);
  // Actualizar las ciudades encontradas
  lbCiudades.Clear;
  for I := 0 to (lCiudades.cont - 1) do begin
    lbCiudades.Items.Add(lCiudades.ciudades[i].nombre + ', ' + lCiudades.ciudades[i].pais);
  end;

  pcResult.ActivePage := tsCiudades;
  lbCiudades.SetFocus;

end;

procedure TForm1.btnProxHorasClick(Sender: TObject);
var
  Str, StrW:String;
  ATiempoProxHoras:TTiempoProxHoras;
  AForecastData:TForecastStruct;
begin
	// proximos 14 das...
  try
    Str := AnsiReplaceText(edtCiudad.Text, CHAR_SPACE, '%20');
    StrW := Format(URL_SEARCH_CITY_VARIOS,[UTF8Encode(Str)]) + STR_APPID;
    Self.FResponse := Self.IdHTTP.Get(StrW);
  except
    on E:Exception do begin
      MessageDlg('Error:' + E.Message, mtError, [mbOK], 0);
    end;
  end;
  // Hacer un parse de la respuesta
  mmData.Lines.Text := GetFormattedResponse(Self.FResponse);
	// Hacer un parse de la respuesta
  TlkJSONbase(objResp) := TlkJSON.ParseText(Self.FResponse);

	// parsear la respuesta
  ParseTiempoCiudadesHist(objResp, ATiempoProxHoras);
  // Actualizar datos en pantalla
  ActualizarInfoTiempo(ATiempoProxHoras);
end;


procedure TForm1.cbxVclStylesChange(Sender: TObject);
begin
{$IFDEF DELPHIXE_UP}
  TStyleManager.SetStyle(cbxVclStyles.Text);
{$ENDIF}
end;

end.
